package betclic.test

import betclic.test.configuration.*
import io.ktor.server.application.*
import kotlinx.coroutines.runBlocking

fun main(args: Array<String>) {
    io.ktor.server.netty.EngineMain.main(args)
}

fun Application.module() {
    configure()
    initialize()
}

fun Application.configure() {
    configureKoin()
    configureSerialization()
    configureRouting()
}

fun Application.initialize() = runBlocking {
    migrateTables()
}