package betclic.test

import TestDynamoDbConfiguration
import betclic.test.configuration.DynamoDbMigration
import io.ktor.server.application.*
import org.koin.core.context.loadKoinModules

import org.koin.dsl.module

fun Application.module() {
    configure()
    // override Database module with testContainers
    loadKoinModules(testDatabaseModule)
    initialize()
}

val testDatabaseModule = module {
    single { TestDynamoDbConfiguration.createDynamoDbClient() }
    single { TestDynamoDbConfiguration.createDataSource(get()) }
    single { DynamoDbMigration() }
}