package betclic.test.player

import BaseIntegrationTest
import io.ktor.client.request.*
import io.ktor.http.*
import org.assertj.core.api.Assertions.assertThat
import org.junit.Test
import org.koin.test.inject
import kotlin.test.assertEquals


private const val PLAYER_NAME = "Clement"

class PlayerIntegrationTest : BaseIntegrationTest() {

    @Test
    fun `When calling player creation, a player should be saved in DB`() = iTest {
        val response = client.post("/players") {
            header(HttpHeaders.ContentType, ContentType.Text.Plain)
            setBody(PLAYER_NAME)
        }

        assertEquals(HttpStatusCode.Created, response.status)

        val playerRepository: PlayerRepository by inject()
        val players = playerRepository.findAll()
        assertThat(players).hasSize(1)
        assertThat(players.first()).extracting("pseudo", "pointsNumber")
            .containsExactly(PLAYER_NAME, 0)
    }
}
