package betclic.test.player

import io.mockk.coEvery
import io.mockk.coVerify
import io.mockk.just
import io.mockk.mockk
import io.mockk.runs
import kotlinx.coroutines.runBlocking
import org.junit.Test

class PlayerServiceTest {


    private val playerRepository: PlayerRepository = mockk()

    private val playerService: PlayerServiceImpl = PlayerServiceImpl(playerRepository)
    private val john = "John"
    private val player1 = Player(pseudo = john)

    @Test
    fun `should create a new player in database`() {
        coEvery { playerRepository.createNewPlayer(player1) } just runs
        runBlocking { playerService.createNewPlayer(john) }
        coVerify(exactly = 1) { playerRepository.createNewPlayer(player1) }
    }

}